; BIOS zaladowal pierwszy sektor dyskietki do 7C00h, 
; tak ma w zwyczaju od 0x86 (-;
 org 7C00h

; 16 bitowa czesc kodu
[BITS 16]
start:
    ; ustawienie stosu dla rybu rzeczywistego)
	mov ax, 07c0h
	mov ss, ax
	mov esp, 0400h 

    ; inicjacja trybu wideo 80x25 (tekstowego)
	xor ah, ah
	mov al, 3
	int 10h

    ; ladowanie jadra pod adres 1000h:0000h
	xor ah, ah
	int 10h

	mov ah, 2
	mov al, 0x11 ; czytamy do konca sciezki (17 sektorow) 
	mov ch, 0
	mov cl, 2
	mov dh, 0
	mov bx, 1000h
	mov es, bx
	xor bx, bx
	int 13h

	mov ah, 2
	mov al, 0x12
	mov ch, 1 ; zmieniamy sciezke
	mov cl, 1 ; i czytamy ja od poczatku
	mov dh, 0
	mov bx, 1220h ; po 8 kB od 0x1000
	mov es, bx
	xor bx, bx
	int 13h



;	Testowowo wystawiamy cos na obraz
;	mov ax,0xb800
;	mov gs,ax
;	mov word [gs:0],0x641

    ; ladujemy tablice deskryptorow
	lgdt [gdtr]
    
    ; przechodzimy do pmode
	mov eax, cr0
	or eax, 1
	mov cr0, eax

    ; mozemy teraz wskoczyc w 32 bitowy kod
	jmp codesel:pmode

; teraz kod 32 bitowy (ustawienie poprawnych rejestrow segmentowych
; zaznaczenie swojego dzialania i skok do jadra w C)
[BITS 32]
pmode:
	mov ax, datasel
	mov ss, ax
	mov ds, ax
	mov es, ax
	mov fs, ax
	mov gs, ax    
	mov esp, 0x8000
	; juz w pmode wyswietlamy jakis znak zycia (biala litera 'A')
	mov word [0xB8002],0x741
	; skaczemy do kodu w C
	jmp codesel:0x10000

; znowu kod 16 bitowy
; tu sa dane (tablica deskryptorow) i musza byc zapisane 16 biotowo
; to troche taka sekcja .date w zwyklym programie
[BITS 16]
gdtr:
    dw gdt_end - gdt - 1
    dd gdt
gdt:
; nullsel
nullsel equ $-gdt
gdt0:
    dd 0
    dd 0
; code
codesel equ $-gdt
code_gdt:    
    dw 0x0FFFF
    dw 0
    db 0
    db 10011010b
    db 11001111b
    db 0
; data
datasel equ $-gdt
data_gdt:    
    dw 0x0FFFF
    dw 0
    db 0
    db 10010010b
    db 11001111b
    db 0
gdt_end:

; bootsector musi byc pelnym sektorem z ostatnimi bajtami AA55h
; wiec musimy zadoscuczynic wymaganiom BIOS'u
times 510 - ($ - start) db 0
db 55h
db 0AAh
