#include "intr.h"
#include "asm-io.h"

#define __byte(x,y) 	(((unsigned char *)&(y))[x])
#define cached_21	(__byte(0,cached_irq_mask))
#define cached_A1	(__byte(1,cached_irq_mask))

static unsigned int cached_irq_mask = 0xffff;

void set_gate(int n, unsigned long irq_handle, unsigned short type) {
	char t[16];

	idt[n].offset_0  = irq_handle;
	idt[n].selector  = 0x08;
	idt[n].type      = type;
	idt[n].offset_16 = (irq_handle >> 16);
	itostr( (unsigned long)(idt[n].offset_0 + (idt[n].offset_16 << 16 )), t);
	itostr( (unsigned long)(irq_handle), t);
	b_print( t, 8 );
}

void disable_irq(unsigned int irq) {
	unsigned int mask = (1 << irq);
	cached_irq_mask |= mask;
	if (irq & 8) {
		outb(cached_A1,0xA1);
	} else {
		outb(cached_21,0x21);
	}
}

void enable_irq(unsigned int irq) {
	unsigned int mask = ~(1 << irq);
	cached_irq_mask &= mask;
	if (irq & 8) {
		outb(cached_A1,0xA1);
	} else {
		outb(cached_21,0x21);
	}
}
