#include "inc/asm-io.h"
#include "inc/intr.h"
#include "inc/irqinit.h"
#include "inc/utils.h"

extern void _irq1( void );

void b_print( const char* str, unsigned char format ) {
	unsigned char* vga = (unsigned char*) 0xb8000;
	str ++;
	while( *str != 0 ) {
		*(vga ++) = *(str ++);
		*(vga ++) = format;
	}
}

// entry point of kernel
void __main()
{
	int i = 0;
	for( i = 0; i < 16; i ++ ) {
		disable_irq(i);
	}
	enable_irq(1);
	// for testing purposes set_gate prints _irq1 address given
	set_gate(0x21, (unsigned long)&_irq1, 0x8E00);
	sti();
	for(;;);
	//mov word [0xB8002],0x741
}
